package test;

import aterm.pure.PureFactory;

public class ListFactory extends PureFactory
{
  private aterm.AFun funModule_Default;
  private Module protoModule_Default;
  private aterm.AFun funModules_List;
  private Modules protoModules_List;
  private aterm.AFun funModules_Body;
  private Modules protoModules_Body;
  private aterm.AFun funModules_Empty;
  private Modules protoModules_Empty;
  private aterm.AFun funModuleList_Modules;
  private ModuleList protoModuleList_Modules;

  public ListFactory()
  {
     super();
     initialize();
  }

  public ListFactory(int logSize)
  {
     super(logSize);
     initialize();
  }

  private void initialize()
  {
    Module.initialize(this);

    Module_Default.initializePattern();
    funModule_Default = makeAFun("Module_Default", 1, false);
    protoModule_Default = new Module_Default();

    Modules.initialize(this);

    Modules_List.initializePattern();
    funModules_List = makeAFun("Modules_List", 2, false);
    protoModules_List = new Modules_List();

    Modules_Body.initializePattern();
    funModules_Body = makeAFun("Modules_Body", 2, false);
    protoModules_Body = new Modules_Body();

    Modules_Empty.initializePattern();
    funModules_Empty = makeAFun("Modules_Empty", 0, false);
    protoModules_Empty = new Modules_Empty();

    ModuleList.initialize(this);

    ModuleList_Modules.initializePattern();
    funModuleList_Modules = makeAFun("ModuleList_Modules", 1, false);
    protoModuleList_Modules = new ModuleList_Modules();

  }

  protected Module makeModule_Default(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoModule_Default) {
      protoModule_Default.initHashCode(annos,fun,args);
      return (Module) build(protoModule_Default);
    }
  }

  public Module makeModule_Default(String _string) {
    aterm.ATerm[] args = new aterm.ATerm[] {makeAppl(makeAFun(_string, 0, true))};
    return makeModule_Default( funModule_Default, args, empty);
  }

  protected Modules makeModules_List(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoModules_List) {
      protoModules_List.initHashCode(annos,fun,args);
      return (Modules) build(protoModules_List);
    }
  }

  public Modules makeModules_List(Module _first, Modules _next) {
    aterm.ATerm[] args = new aterm.ATerm[] {_first, _next};
    return makeModules_List( funModules_List, args, empty);
  }

  protected Modules makeModules_Body(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoModules_Body) {
      protoModules_Body.initHashCode(annos,fun,args);
      return (Modules) build(protoModules_Body);
    }
  }

  public Modules makeModules_Body(Module _first, Modules _next) {
    aterm.ATerm[] args = new aterm.ATerm[] {_first, _next};
    return makeModules_Body( funModules_Body, args, empty);
  }

  protected Modules makeModules_Empty(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoModules_Empty) {
      protoModules_Empty.initHashCode(annos,fun,args);
      return (Modules) build(protoModules_Empty);
    }
  }

  public Modules makeModules_Empty() {
    aterm.ATerm[] args = new aterm.ATerm[] {};
    return makeModules_Empty( funModules_Empty, args, empty);
  }

  protected ModuleList makeModuleList_Modules(aterm.AFun fun, aterm.ATerm[] args, aterm.ATermList annos) {
    synchronized (protoModuleList_Modules) {
      protoModuleList_Modules.initHashCode(annos,fun,args);
      return (ModuleList) build(protoModuleList_Modules);
    }
  }

  public ModuleList makeModuleList_Modules(Modules _modules) {
    aterm.ATerm[] args = new aterm.ATerm[] {_modules};
    return makeModuleList_Modules( funModuleList_Modules, args, empty);
  }

}
